################################################################
## This file is part of the GeoEspacoPEC source code
##
## Copyright (C) 2009 LabTEVE (http://www.de.ufpb.br/~labteve),
## Federal University of Paraiba.
## All rights reserved.
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public
## License along with this program; if not, write to the Free
## Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.
################################################################


import sys, time, math, os, random
import passatempos

###############
# Classe q ira carregar as outras classes
# A ordem dos metodos eh muito importante para a execucao
###############
class Base(object):

	def __init__(self, i):
		print "Carregando os passatempos"
		p = passatempos.Passatempos()
		dica = []
		
		if (p.dadosPassatempo(i) == 0): #Retorna os passatempos do passatempos.txt
			p.carregarResposta() #Carrega as respostas do respostas.txt
			p.localizarRespostasPassatempo() #Carregar as respostas dos Passatempos
			resposta = p.sortearPergunta() #Dentre as possiveis sorteia um
			p.dadosResposta()
			p.carregarModelo()
			self.QuestaoP = p.obterQuestaoSelecionada()
			self.RespostaCorretaP = p.obterRespostaCorretaSelecionada()
			self.OutrasRespostasP = p.obterOutrasRespostasSelecionadas()
			self.ModeloP =  p.obterModeloPassatempoSelecionado()
			
			DicaP_ = p.obterDicaSelecionada()
			dica = p.tratarDicas(DicaP_)
			self.DicaP = dica[0]+"\n"+dica[1]
		else:
			print "Passatempo Nao Existe"
		print "Carregando os Objetos Colididos"
	
	def obterQuestaoP(self):return self.QuestaoP

	def obterRespostaCorretaP(self):return self.RespostaCorretaP
	
	def obterOutrasRespostasP(self):return self.OutrasRespostasP
	
	def obterModeloP(self):return self.ModeloP

	def obterObjetoS(self):return self.ObjetoS

	def obterMessageS(self): return self.MessageS
	
	def obterDicaP(self): return self.DicaP

###############
# Classe relacionada aos Objetos e suas colisoes
###############
class ObjetosColididos(object):
	
	def __init__(self):
		print "\n ######### (__init__) #########"
		self.objetos2 = []
		self.mensagens2 = []
		self.objetos3 = []
		self.mensagens3 = []
		self.objetos4 = []
		self.mensagens4 = []

		# Carregar e trata dados do arquivo objNivel1
		self.carregaArquivo1()
		self.carregaObjetos(self.features, self.objetos2)
		self.carregaMens(self.features, self.mensagens2)
		
		# Carregar e trata dados do arquivo objNivel2
		self.carregaArquivo2()
		self.carregaObjetos(self.features3, self.objetos3)
		self.carregaMens(self.features3, self.mensagens3)
		
		self.carregaArquivo3()
		self.carregaObjetos(self.features4, self.objetos4)
		self.carregaMens(self.features4, self.mensagens4)

	########
	##@DESCRIPTION: Carrega o arquivo de Objetos e mensagens do nivel 2
	##@PARAMETERES: none
	########
	def carregaArquivo1(self):
		fileHandle = open ('arq/objNivel1')
		dados = fileHandle.read()
		data = dados.split("****")
		i = 0
		j = 0
		self.features = []
		elements = []

		for i in range(0,(len(data)-1)):
			size = len(data)
			if (i == 0):  #desconsidera o primeiro elemento da lista
				i = i+1
			else:
				elements.append(data[i])
				i = i+1
				j = j+1
		
		for x in elements:
			self.dados2temp = x.split("\n")
			## remover o primeiro e o ultimo elemento ''
			self.dados2temp.pop(0)
			self.dados2temp.pop(len(self.dados2temp)-1)
			self.features.append(self.dados2temp)

		fileHandle.close()

	########
	##@DESCRIPTION: Carrega o arquivo de Objetos e mensagens do nivel 3
	##@PARAMETERES: none
	########
	def carregaArquivo2(self):
		fileHandle = open ('arq/objNivel2')
		dados = fileHandle.read()
		data = dados.split("****")

		i = 0
		j = 0
		self.features3 = []
		elements = []

		for i in range(0,(len(data)-1)):
			size = len(data)
			if (i == 0):  #desconsidera o primeiro elemento da lista
				i = i+1
			else:
				elements.append(data[i])
				i = i+1
				j = j+1

		for x in elements:
			self.dados2temp = x.split("\n")
			## remover o primeiro e o ultimo elemento ''
			self.dados2temp.pop(0)
			self.dados2temp.pop(len(self.dados2temp)-1)
			self.features3.append(self.dados2temp)

		fileHandle.close()
	
	
	########
	##@DESCRIPTION: Carrega o arquivo de Objetos e mensagens do nivel 3
	##@PARAMETERES: none
	########
	def carregaArquivo3(self):
		fileHandle = open ('arq/objNivel3')
		dados = fileHandle.read()
		data = dados.split("****")
	
		i = 0
		j = 0
		self.features4 = []
		elements = []
		
		for i in range(0,(len(data)-1)):
			size = len(data)
			if (i == 0):  #desconsidera o primeiro elemento da lista
				i = i+1
			else:
				elements.append(data[i])
				i = i+1
				j = j+1
		
		for x in elements:
			self.dados2temp = x.split("\n")
			self.dados2temp.pop(0)
			self.dados2temp.pop(len(self.dados2temp)-1)
			self.features4.append(self.dados2temp)

		fileHandle.close()
	
	########
	##@DESCRIPTION: Trata as mensagens e as armazena em um array de mensagens
	##@PARAMETERES: none
	########
	def carregaMens(self, listaDados, arrayMens):
		for x in  range(0,(len(listaDados))):
			self.mensTemp = listaDados[x][0].split(":")
			arrayMens.append(self.mensTemp[1])

	########
	##@DESCRIPTION: Trata os objetos e os armazena em um array de objetos
	##@PARAMETERES: none
	########
	def carregaObjetos(self, listaDados, arrayObj):
		for x in  range(0,(len(listaDados))):
			self.objTemp = listaDados[x][1].split(":")
			arrayObj.append(self.objTemp[1])
	

	def retornaListaObjetosNivel2(self):return self.objetos2
	
	def retornaListaMessNivel2(self):return self.mensagens2
	
	def retornaListaObjetosNivel3(self):return self.objetos3
	
	def retornaListaMessNivel3(self):return self.mensagens3
	
	def retornaListaObjetosNivel4(self):return self.objetos4
	
	def retornaListaMessNivel4(self):return self.mensagens4
