################################################################
## This file is part of the GeoEspacoPEC source code
##
## Copyright (C) 2009 LabTEVE (http://www.de.ufpb.br/~labteve),
## Federal University of Paraiba.
## All rights reserved.
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public
## License along with this program; if not, write to the Free
## Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.
################################################################

from pandac.PandaModules import *
import direct.directbase.DirectStart
from direct.gui.OnscreenText import OnscreenText 
from direct.task.Task import Task 
from direct.showbase.DirectObject import DirectObject 
from direct.gui.DirectGui import *
from pandac.PandaModules import *
from direct.interval.IntervalGlobal import *
# Determine screen properties.
screenWidth = base.win.getProperties().getXSize()
screenHeight = base.win.getProperties().getYSize()
screenCenterX = screenWidth/2
screenCenterY = screenHeight/2
screenAspect = float(screenWidth)/screenHeight
X_PADRAO = -1.3
textObject = OnscreenText(text = "", pos = (0.95,-0.95), 
scale = 0.07,fg=(1,0.5,0.5,1),align=TextNode.ACenter,mayChange=1)
floaterPos = [0, -2, 1]
cameraPos = [0, 15, 10]

###############
# Classe responsavel por criar a janela de dicas
###############

class createWindow(DirectObject):
	## Definio e configurao do objeto FRAME
	myDirectObject = DirectFrame(text="",frameColor=(1,1,1,1),pos=(0,0,0))
	
	def __init__(self,texto):
		#texto: texto a ser inserido na janela
		
		self.dica = TextNode('dica')
		self.dica.setText("Pressione ENTER para continuar")
		self.dica.setWordwrap(15.0)
		self.dica.setTextColor(1, 0.5, 0.5, 1)
		self.dicaNode = aspect2d.attachNewNode(self.dica)
		self.dica.setAlign(self.dica.ACenter)
		self.dicaNode.setPos(X_PADRAO+1.3, 0,0.1)
		self.dica.setShadow(0.05, 0.05)
		self.dica.setShadowColor(0, 0, 0, 1)
		self.dicaNode.setScale(0.08)
		self.tempo = 0
		self.myDirectObject['text'] = "teste"
		self.myDirectObject['frameSize'] = (-0.7,0.7,-0.3,0.8)
		self.myDirectObject['text_scale'] = 0.05
		t_pos = (self.myDirectObject.getCenter()[0],self.myDirectObject.getCenter()[1] + 0.40)
		self.myDirectObject['text_pos'] = (t_pos)
		self.myDirectObject['relief'] = 5
		self.myDirectObject['borderWidth'] = (0.03,0.03)

		self.texto = TextNode('texto')
		self.texto.setText(texto)
		self.texto.setWordwrap(5.0)
		self.texto.setAlign(self.texto.ACenter)
		self.myDirectObject['text'] = self.texto.getText()

	## Destrutor da classe
	def destroy(self,inicio1):
	
		self.myDirectObject['state']="DISABLED"
		if (self.myDirectObject['text'] == "PERGUNTA"):
			self.myDialog.destroy()
		self.myDirectObject['text'] = ""
		self.myDirectObject['frameSize'] = (-1000,-1000,-1000,-1000)
		self.dica.setText("")
		self.ignore("enter")
		if(inicio1 == 1):
			return 1
		if(inicio1 == 0):
			return 0
