################################################################
## This file is part of the GeoEspacoPEC source code
##
## Copyright (C) 2009 LabTEVE (http://www.de.ufpb.br/~labteve),
## Federal University of Paraiba.
## All rights reserved.
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public
## License along with this program; if not, write to the Free
## Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.
################################################################

################
#LoadCenario.py#	
################

from pandac.PandaModules import *
import direct.directbase.DirectStart
from direct.gui.OnscreenText import OnscreenText 
from direct.task.Task import Task 
from direct.showbase.DirectObject import DirectObject 
from direct.gui.DirectGui import *

from pandac.PandaModules import *
from direct.interval.IntervalGlobal import *


import createWindow
import world
import MaquinaDeEstados
import passatempos
import baseDeDados
import sys, time, math, os, random

SPEED = 15

##Parameters utilized in the viewport
VPColor = VBase4(0,0,0,1.0)

VPRot = [32,24,36]

screenWidth = base.win.getProperties().getXSize()
screenHeight = base.win.getProperties().getYSize()
screenCenterX = screenWidth/2
screenCenterY = screenHeight/2
screenAspect = float(screenWidth)/screenHeight
X_PADRAO = -1.3
textObject = OnscreenText(text = "", pos = (0.95,-0.95), 
scale = 0.07,fg=(1,0.5,0.5,1),align=TextNode.ACenter,mayChange=1)

floaterPos = [0, -2, 1]
cameraPos = [0, 15, 10]

class LoadJogo(DirectObject):
	props = WindowProperties()
	props.setTitle("GeoEspaco PEC - Um jogo educacional para matematica")
	base.win.requestProperties(props)
	
	def __init__(self):
		self.a = 0
		self.creditos=0
		self.imageObject = OnscreenImage(image = "imagens/abertura.jpg", pos = (0, 0, 0),scale=(1.35,1,1))
		self.title = OnscreenText(text="Aperte \"ENTER\" para continuar...",style=1, fg=(1,1,1,1),pos=(0,-0.93), scale = .07)
		self.started = 0
		self.accept("enter",self.CarregaInicio)

	def CarregaInicio(self):
		self.ignore("enter")
		if self.creditos==1:
			self.imageObject3.destroy()
			self.botaoVoltar.destroy()
			self.botaoIniciar.destroy()
			self.botaoSair.destroy()
		if self.started == 0:
			self.started = 1
			self.imageObject.destroy()
			self.title.destroy()
			self.imageObject2 = OnscreenImage(image = "imagens/historia.png", pos = (0, 0, 0),scale=(1.35,1,1))
			self.botaoCreditos = DirectButton(text = ("Creditos"),command=self.Creditos,scale=(.13,1,.1), frameSize=(-1.5,1.65,-0.25,0.8))
			self.botaoCreditos.setPos(-0.70,1,-0.85)
			self.botaoCreditos2 = DirectButton(text = ("Iniciar"),command=self.CarregaJogo,scale=(.2,1,.15))
			self.botaoCreditos2.setPos(0.0,-1.2,-0.865)
			self.botaoCreditos3 = DirectButton(text = ("Sair"),command=sys.exit,scale=(.13,1,.1),frameSize=(-1.5,1.65,-0.25,0.8))
			self.botaoCreditos3.setPos(0.70,-0.25,-0.85)
	
	def CarregaJogo(self):
		if self.creditos==1:
			self.imageObject3.destroy()
			self.botaoIniciar.destroy()
			self.botaoVoltar.destroy()
			self.botaoSair.destroy()
		self.imageObject2.destroy()
		self.botaoCreditos.destroy()
		self.botaoCreditos2.destroy()
		self.botaoCreditos3.destroy()
		
		w = world.World()#carrega o jogo

	def Creditos(self):
		self.creditos = 1
		self.imageObject3 = OnscreenImage(image = "imagens/creditos.png", pos = (0, 0, 0),scale=(1.35,1,1))
		self.botaoVoltar = DirectButton(text = ("Voltar"),command=self.CarregaInicio,scale=(.13,1,.1), frameSize=(-1.5,1.65,-0.25,0.8))
		self.botaoVoltar.setPos(-0.70,0,-0.85)
		self.botaoIniciar = DirectButton(text = ("Iniciar"),command=self.CarregaJogo,scale=(.2,1,.15))
		self.botaoIniciar.setPos(0.0,-1.2,-0.865)
		self.botaoSair = DirectButton(text = ("Sair"),command=sys.exit,scale=(.13,1,.1),frameSize=(-1.5,1.65,-0.25,0.8))
		self.botaoSair.setPos(0.70,-0.25,-0.85)

LoadJogo()
run()#roda o programa


