################################################################
## This file is part of the GeoEspacoPEC source code
##
## Copyright (C) 2009 LabTEVE (http://www.de.ufpb.br/~labteve),
## Federal University of Paraiba.
## All rights reserved.
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public
## License along with this program; if not, write to the Free
## Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.
################################################################

from direct.gui.DirectLabel import DirectLabel
from direct.showbase.DirectObject import DirectObject 
import direct.directbase.DirectStart

class Timer(DirectObject):
   def __init__(self):
      self.TotalTime  = 0
      self.TimerLabel = DirectLabel()
      self.TimerLabel.reparentTo(aspect2d)
     

   def GenTimerString(self, task):
      seconds = self.TotalTime % 60
      minutes = self.TotalTime / 60
      TimerLabel['text'] = str(str(minutes) +  ' : ' + str(seconds))
      self.TotalTime -= 1

   def StartTimer(self):
      taskMgr.add(self.GenTimerString, 'GenTimerString')

   def AddTime(self, timeToInsert):
      self.TotalTime += timeToInsert

   def DecreaseTime(self, timeToDecrease):
      self.TotalTime += timeToDecrease

   def InsertTotalTime(self, TotalTime):
      self.TotalTime = TotalTime 
Timer()      
run()
