################################################################
## This file is part of the GeoEspacoPEC source code
##
## Copyright (C) 2009 LabTEVE (http://www.de.ufpb.br/~labteve),
## Federal University of Paraiba.
## All rights reserved.
##
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public
## License along with this program; if not, write to the Free
## Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
## Boston, MA 02110-1301, USA.
################################################################

################
#   world.py   #	
################
from pandac.PandaModules import *
import direct.directbase.DirectStart
from direct.gui.OnscreenText import OnscreenText 
from direct.task.Task import Task 
from direct.showbase.DirectObject import DirectObject 
from direct.gui.DirectGui import *

from pandac.PandaModules import *
from direct.interval.IntervalGlobal import *

import sys, time, math, os, random
import createWindow
import world
import MaquinaDeEstados
import passatempos
import baseDeDados
import sys, time, math, os, random

SPEED = 15

#Parameters utilized in the viewport
VPColor = VBase4(0,0,0,1.0)
VPRot = [32,24,36]

screenWidth = base.win.getProperties().getXSize()
screenHeight = base.win.getProperties().getYSize()
screenCenterX = screenWidth/2
screenCenterY = screenHeight/2
screenAspect = float(screenWidth)/screenHeight
X_PADRAO = -1.3
textObject = OnscreenText(text = "", pos = (0.95,-0.95), 
scale = 0.07,fg=(1,0.5,0.5,1),align=TextNode.ACenter,mayChange=1)
floaterPos = [0, -2, 1]
cameraPos = [0, 15, 10]

#####GLOBAL VARIABLES USED IN THE TIMER
MINUTES = 32
TOTAL_TIME = MINUTES*(60.0)
######################################

############
###Main Class
############
class World(DirectObject):

    def addInstructions(x, y):
	    return OnscreenText(text="pos = ", style=1, fg=(1,1,1,1),pos=(x,y), align=TextNode.ALeft, scale = .05, mayChange = 1)

    def ColocaInstrucoes(self):
        OnscreenText("Moving In The Library",style=1,fg=(1,0,0,1),pos=(1.3,-0.95),align=TextNode.ARight,scale=.07)
        OnscreenText("[ESC] Sair",style=1,fg=(1,0,0,1),pos=(-1.3,0.95),align=TextNode.ALeft,scale=.05)
        OnscreenText("[Setas Direita/Esquerda] - Rotaciona",style=1,fg=(1,0,0,1),pos=(-1.3,0.90),align=TextNode.ALeft,scale=.05)
        OnscreenText("[Setas Cima/Baixo] - Move",style=1,fg=(1,0,0,1),pos=(-1.3,0.85),align=TextNode.ALeft,scale=.05)
	OnscreenText("[D] - Ultima Dica",style=1,fg=(1,0,0,1),pos=(-1.3,0.80),align=TextNode.ALeft,scale=.05)
	OnscreenText("[H] - Help",style=1,fg=(1,0,0,1),pos=(-1.3,0.75),align=TextNode.ALeft,scale=.05)


    ########
    ##@DESCRIPTION: Rotates the key point (and its children). Determine how much to rotate the key point.
    ##@PARAMETERES: coordenada de mouse
    ########
    def changeView(self, mouseX):
        if base.win.movePointer(0, screenCenterX, screenCenterY):
            mouseXchange = mouseX - screenCenterX
            self.keyPointR -= mouseXchange
        if self.keyPointR < 0:
            self.keyPointR += 360
        if self.keyPointR >= 360:
            self.keyPointR -= 360
        # Update the key point orientation.
        self.keyPoint.setH(self.keyPointR)

    #######
    ##@DESCRIPTION: Exibindo filmes do jogo
    ##@PARAMETERES: none
    ########
    def playMovie(self):
		################### Exibindo filmes do jogo #########################
		
		self.destroyWindow()
		self.filme = loader.loadTexture("videos/fim.avi")

		if self.filme == None:
			print "Erro ao exibir filme %s" % movie
			return
		
		self.filme.setLoop(False)
		self.filme.play()
		if (base.sfxManagerList[0] == None):
			print "Nao ha nenhum gerenciador de filmes instalado!"
			return

		if (self.filme.getType().getName() != "MovieTexture"):
			print "Suporte a MovieTexture nao habilitado!"
			return

		self.cm = CardMaker("My Fullscreen Card");
		self.cm.setFrameFullscreenQuad()
		self.cm.setUvRange(self.filme)
    		self.card = NodePath(self.cm.generate())
    		self.card.reparentTo(render2d)
    		self.card.setTexture(self.filme)

    ########
    ##@DESCRIPTION: Funcao que carrega os modelos a serem exibidos
    ##@PARAMETERES: none
    ########
    def LoadModels(self):
	self.floater = NodePath(PandaNode("floater"))
	self.floater.reparentTo(render)
	
	camera.setPosHpr(0, -20, 6, 0, 0, 0)#define a posio da camera
	self.catacumba = loader.loadModel("models/catacumba.bam")
	self.catacumba.reparentTo(render)
	self.catacumba.setPos(0,42,0)
	
	self.salasecreta = loader.loadModel("models/sala.bam")
	self.salasecreta.reparentTo(render)
	self.salasecreta.setPos(0,42,0)
        self.environ2= loader.loadModel("models/biblioteca_jogo.bam")
	self.environ2.reparentTo(render)
	
	self.environ2.setPos(0,42,0)
	self.chair = loader.loadModel("models/cadeira.bam")
	self.chair.setPos(0,42,0)
	self.chair.reparentTo(render)
	self.chairTrap = loader.loadModel("models/cadeira_trapezio.bam")
	self.chairTrap.setPos(0,42,0)
	self.chairTrap.reparentTo(render)
	self.chairParalel = loader.loadModel("models/cadeira_paralelogramo.bam")
	self.chairParalel.setPos(0,42,0)
	self.chairParalel.reparentTo(render)
	self.chairHexagon = loader.loadModel("models/cadeira_hexagono.bam")
	self.chairHexagon.setPos(0,42,0)
	self.chairHexagon.reparentTo(render)
	self.cubeAbajur = loader.loadModel("models/abajur_cubo.bam")
	self.cubeAbajur.setPos(0,42,0)
	self.cubeAbajur.reparentTo(render)
	self.piramidAbajur = loader.loadModel("models/abajur_piramide.bam")
	self.piramidAbajur.setPos(0,42,0)
	self.piramidAbajur.reparentTo(render)
	self.cilinderAbajur = loader.loadModel("models/abajur_cilindro.bam")
	self.cilinderAbajur.setPos(0,42,0)
	self.cilinderAbajur.reparentTo(render)
	self.piano = loader.loadModel("models/piano.bam")
	self.piano.setPos(0,42,0)
	self.piano.reparentTo(render)
	self.door1 = loader.loadModel("models/porta1.bam")
	self.door1.setPos(0,42,0)
	self.door1.reparentTo(render)
	self.door2 = loader.loadModel("models/porta2.bam")
	self.door2.setPos(0,42,0)
	self.door2.reparentTo(render)
        base.disableMouse()
        self.avatar=NodePath(PandaNode("keyPoint"))
        self.avatar.reparentTo(render)#
        self.avatar.setScale(0.4,0.4,0.4)#
        self.avatar.setPos(0,-10,12)#
	self.avatar.setH(self.avatar.getH()+180) #rotaciona o personagem para que ele esteja de costas para camera  
	base.camera.setH(self.avatar.getH())  
	self.x_pos = 0.0
	self.y_pos = 0.0
	self.z_pos = 0.0
	

    ########
    ##@DESCRIPTION: Funcao que carrega as luzes
    ##@PARAMETERES: none
    ########
    def LoadLights(self):
		self.countErrors = 0
	        self.tries = 0 ####quantidade de erros
		self.plight = PointLight('plight')
		self.plight.setColor(VBase4(1, 1, 1, 1))
		self.plnp = render.attachNewNode(self.plight.upcastToPandaNode())
		self.plnp.setPos(0,0,100)
		render.setLight(self.plnp)
		# Luz direcional que aponta para o personagem
		self.dlight = DirectionalLight('dlight')
		self.dlight.setColor(VBase4(0.5, 0.5, 0.5, 0.2))
		self.dlnp = render.attachNewNode(self.dlight.upcastToPandaNode())
		self.dlnp.lookAt(-self.avatar.getX(), 0, self.avatar.getZ()+100 )
		render.setLight(self.dlnp)
		# Luz ambiente para mostrar maior claridade nas texturas
		self.alight = AmbientLight('alight')
		self.alight.setColor(VBase4(1, 1, 1, 1))
		self.alnp = render.attachNewNode(self.alight.upcastToPandaNode())
		render.setLight(self.alnp)

    #########
    ##@DESCRIPTION: Visao(self,alt)
    ##@PARAMETERES:recebe como parametro valor correspondente a visao escolhida (1-primeira pessoa e 0-for terceira pessoa) 
    ## e muda para a visao desejada 
    ########
    def Visao(self,alt):
	    if alt == 1:####primeira pessoa
		    camera.setPos(self.avatar.getPos())  
		    camera.setH(self.avatar.getH()-180)
		    self.alt=1

            if alt == 0:
		    camera.setPos(self.avatar.getPos() - Point3(0,20,0))
		    self.alt=0
	 
    ########
    ##@DESCRIPTION:setKey()
    ##@PARAMETERES:nome da tecla e o outro o valor da mesma usado para controlar os comandos do teclado
    #######
    def setKey(self, key, value):
	self.keyMap[key] = value
		
    ########
    ##@DESCRIPTION:move()
    ##@PARAMETERES:recebe como parametro uma task , que ativa o funcionamento da funcao e movimenta o personagem no mundo
    ########
    def move(self,task):
	startpos = self.avatar.getPos()
	elapsed = task.time - self.prevtime
	count = 0
	
	self.pos = self.avatar.getPos()
	self.angle = self.avatar.getH()	
		
	if self.alt==0:
		base.camera.lookAt(self.avatar)
        	camright = base.camera.getNetTransform().getMat().getRow3(0)
        	camright.normalize()
		camvec = self.avatar.getPos() - base.camera.getPos()
        	camvec.setZ(0)
		camdist = camvec.length()
        	camvec.normalize()
        	if (camdist > 10.0):
        		base.camera.setPos(base.camera.getPos() + camvec*(camdist-10))
        		camdist = 10.0
        	if (camdist < 5.0):
        		base.camera.setPos(base.camera.getPos() - camvec*(5-camdist))
			camdist = 5.0
			
	if(self.keyMap["interact"]) == 1:
		print "interacting!!!"
		self.pick = 1
	
	self.accept("collide-doorCatacumba",self.isInteracting,[self.keyMap["interact"],3])
	
	#####
	# O passatempo 2  3 e 4 terao seus objetos de interacao randomizados
	#####
	
	if(self.m.retornaNivel()==2):
		self.accept(self.m.objetoColididoN2,self.isInteracting,[self.keyMap["interact"],0])
	if(self.m.retornaNivel()==3):
		self.accept(self.m.objetoColididoN3,self.isInteracting,[self.keyMap["interact"],0])
	if(self.m.retornaNivel()==4):
		self.accept(self.m.objetoColididoN4,self.isInteracting,[self.keyMap["interact"],0])
	if(self.m.retornaNivel() ==5):
		self.accept("collide-piano",self.isInteracting,[self.keyMap["interact"],0])
	if(self.m.retornaNivel() == 6):
		self.accept("collide-door2",self.isInteracting,[self.keyMap["interact"],1])
		self.accept("collide-armor",self.isInteracting,[self.keyMap["interact"],0])
	if(self.m.retornaNivel() == 7):
		self.accept("collide-abajurCat",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-door2",self.isInteracting,[self.keyMap["interact"],1])
	if(self.m.retornaNivel() == 8):
		self.accept("collide-portrait",self.isInteracting,[self.keyMap["interact"],2])
		self.accept("collide-board",self.isInteracting,[self.keyMap["interact"],0])
	
	self.keyMap["interact"] = 0
	self.pick = 0
	
	##
	# Se alguma tecla de movimentacao for pressionada, movimente o personagem na direcao especificada
	##
	if (self.keyMap["left"]!=0):
		self.avatar.setHpr(self.avatar.getH() + elapsed*100,self.avatar.getP(),self.avatar.getR())
		if self.alt==1:
       	        	base.camera.setH(base.camera.getH() + elapsed *100)#####descomentar para mudar p/primeira pessoa
		
	if (self.keyMap["right"]!=0):
		self.avatar.setH(self.avatar.getH() - elapsed*100)
		if self.alt==1:#verifica se a visao esta em primeira pessoa
			base.camera.setH(base.camera.getH() - elapsed *100)
		
	if (self.keyMap["forward"]!=0):
		 backward = self.avatar.getNetTransform().getMat().getRow3(1)
		 backward.setZ(0)
		 backward.normalize()
		 self.avatar.setPos(self.avatar.getPos() - backward*(elapsed)*SPEED)
		 if self.alt==1:#verifica se a visao esta em primeira pessoa 
			base.camera.setPos(self.avatar.getPos())
			
	if (self.keyMap["backward"]!=0):
	         forward = self.avatar.getNetTransform().getMat().getRow3(1)
		 forward.setZ(0)
		 forward.normalize()
		 self.avatar.setPos(self.avatar.getPos() + forward*(elapsed)*SPEED)
		 if self.alt==1:#verifica se a visao esta em primeira pessoa 
		 	base.camera.setPos(self.avatar.getPos())
	self.prevtime = task.time	

	entries = []
	for i in range(self.nodeGroundHandler.getNumEntries()):
		entry = self.nodeGroundHandler.getEntry(i)
		entries.append(entry)
		if (len(entries)>0):
			groundName = entries[0].getIntoNode().getName()
		else:
			self.avatar.setPos(startpos)

	self.totalTime = int(task.time + (self.tries*60*5))
	self.seconds = self.totalTime % 60
        self.minutes = self.totalTime / 60
	self.time1.destroy()

	if self.seconds < 10:
		string = "Tempo decorrido: "+str(self.minutes)+":0"+str(self.seconds)
	if (self.minutes < 10) and (self.seconds < 10):
		string = "Tempo decorrido: "+str(self.minutes)+":0"+str(self.seconds)
	else:
		string = "Tempo decorrido: "+str(self.minutes)+":"+str(self.seconds)
		
	self.time1 = OnscreenText(string,style=1,fg=(1,1,1,1),pos=(0.6,0.9),align=TextNode.ALeft,scale=.07)

	if((task.time + (self.tries*60*5)) >= TOTAL_TIME):
		self.gameOver()
	return Task.cont	

    ########
    ##@DESCRIPTION:Imprimir informacoes na tela
    ##@PARAMETERES:msg a ser imprimida na tela - String
    ######## 
    def	printInstructions(msg):
	    self.x_pos = self.avatar.getX()
	    self.y_pos = self.avatar.getY()
	    self.z_pos = self.avatar.getZ()

    ########
    ##@DESCRIPTION:setar as colisoes dos objetos do cenario
    ##@PARAMETERES:none
    ########
    def setUpCollision(self):
	        ####initialize the pusher
		base.pusher = CollisionHandlerPusher()
		
		######sets the collision mask to the library model
		collisionWall1 =  CollisionNode('wall1')
		#####entrance room
  		polygon = CollisionPolygon(Point3(48,3,10),Point3(48,3,20),Point3(48,20,20),Point3(48,20,10))
		###right side
		collisionWall1.addSolid(CollisionPolygon(Point3(52,-62,10),Point3(52,-62,20),Point3(52,-8,20),Point3(52,-8,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(49,-61,10),Point3(5,-61,10),Point3(5,-61,20),Point3(49,-61,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(8,-8,10),Point3(51,-8,10),Point3(51,-8,20),Point3(8,-8,20)))
		###left side
		collisionWall1.addSolid(CollisionPolygon(Point3(-52,-8,10),Point3(-52,-8,20),Point3(-52,-62,20),Point3(-52,-62,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-8,-61,10),Point3(-54,-61,10),Point3(-54,-61,20),Point3(-8,-61,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-54,-8,10),Point3(-6,-8,10),Point3(-6,-8,20),Point3(-54,-8,20)))
		######room 1
		###right side
	        collisionWall1.addSolid(CollisionPolygon(Point3(48,3,10),Point3(48,3,20),Point3(48,20,20),Point3(48,20,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(52,20,10),Point3(52,20,20),Point3(52,46,20),Point3(52,46,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(48,46,10),Point3(48,46,20),Point3(48,63,20),Point3(48,63,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(44,0,10),Point3(29,0,10),Point3(29,0,20),Point3(44,0,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(35,68,10),Point3(50,68,10),Point3(50,68,20),Point3(35,68,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(15,68,10),Point3(32,68,10),Point3(32,68,20),Point3(15,68,20)))
		##left side
		collisionWall1.addSolid(CollisionPolygon(Point3(-48,20,10),Point3(-48,20,20),Point3(-48,3,20),Point3(-48,3,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-52,46,10),Point3(-52,46,20),Point3(-52,20,20),Point3(-52,20,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-48,63,10),Point3(-48,63,20),Point3(-48,46,20),Point3(-48,46,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-8,0,10),Point3(-24,0,10),Point3(-24,0,20),Point3(-8,0,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-27,0,10),Point3(-45,0,10),Point3(-45,0,20),Point3(-27,0,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-31,68,10),Point3(-15,68,10),Point3(-15,68,20),Point3(-31,68,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-50,68,10),Point3(-33,68,10),Point3(-33,68,20),Point3(-50,68,20)))
		#room 2	
		##right side	
		collisionWall1.addSolid(CollisionPolygon(Point3(48,94,10),Point3(48,94,20),Point3(48,111,20),Point3(48,111,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(48,134,10),Point3(48,134,20),Point3(48,152,20),Point3(48,152,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(31,90,10),Point3(15,90,10),Point3(15,90,20),Point3(31,90,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(50,90,10),Point3(33,90,10),Point3(33,90,20),Point3(50,90,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(30,152,10),Point3(46,152,10),Point3(46,152,20),Point3(30,152,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(13,152,10),Point3(29,152,10),Point3(29,152,20),Point3(13,152,20)))
		##left side
		collisionWall1.addSolid(CollisionPolygon(Point3(-48,111,10),Point3(-48,111,20),Point3(-48,94,20),Point3(-48,94,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-52,132,10),Point3(-52,132,20),Point3(-52,111,20),Point3(-52,111,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-48,149,10),Point3(-48,149,20),Point3(-48,132,20),Point3(-48,132,10)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-15,90,10),Point3(-31,90,10),Point3(-31,90,20),Point3(-15,90,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-33,90,10),Point3(-50,90,10),Point3(-50,90,20),Point3(-33,90,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-28,152,10),Point3(-13,152,10),Point3(-13,152,20),Point3(-28,152,20)))
		collisionWall1.addSolid(CollisionPolygon(Point3(-45,152,10),Point3(-30,152,10),Point3(-30,152,20),Point3(-45,152,20)))
		##portrait collision
		collisionPortrait1 = CollisionNode('portrait')
		collisionPortrait1.addSolid(CollisionPolygon(Point3(-13,154,10),Point3(13,154,10),Point3(13,154,20),Point3(-13,154,20)))
		cPortrait = self.environ2.attachNewNode(collisionPortrait1)
		collisionPortrait1.setIntoCollideMask(BitMask32.bit(0))
		collisionPortrait1.setFromCollideMask(BitMask32.allOff())
		#book with square picture collision
		collisionBookSquare  = CollisionNode('bookSquare')
		collisionBookSquare.addSolid(CollisionPolygon(Point3(-48,63,10),Point3(-48,63,20),Point3(-48,46,20),Point3(-48,46,10)))
		colBookSquare = self.environ2.attachNewNode(collisionBookSquare)
		collisionBookSquare.setIntoCollideMask(BitMask32.bit(0))
		collisionBookSquare.setFromCollideMask(BitMask32.allOff())
		
		#####book with circle  collision
		collisionBookCircle = CollisionNode('bookCircle')
		collisionBookCircle.addSolid(CollisionPolygon(Point3(48,46,10),Point3(48,46,20),Point3(48,63,20),Point3(48,63,10)))
		colBookCircle = self.environ2.attachNewNode(collisionBookCircle)
		collisionBookCircle.setIntoCollideMask(BitMask32.bit(0))
		collisionBookCircle.setFromCollideMask(BitMask32.allOff())

		####book with triangle picture collision
		collisionBook = CollisionNode('book')
		collisionBook.addSolid(CollisionPolygon(Point3(25,0,10),Point3(10,0,10),Point3(10,0,20),Point3(25,0,20)))
		cBook = self.environ2.attachNewNode(collisionBook)
		collisionBook.setIntoCollideMask(BitMask32.bit(0))
		collisionBook.setFromCollideMask(BitMask32.allOff())
		collisionD = CollisionNode('node')
		collisionD.addSolid(CollisionSphere(30,33,10,8))
		collisionD.addSolid(CollisionSphere(-27,110,8,6))
		collisionDD = self.environ2.attachNewNode(collisionD)
		####area externa
		##parte lados
		collisionExterior = CollisionNode('exterior')
		collisionExterior.addSolid(CollisionPolygon(Point3(55,-65,10),Point3(55,160,10),Point3(55,160,20),Point3(55,-65,20)))
		collisionExterior.addSolid(CollisionPolygon(Point3(-55,160,10),Point3(-55,-65,10),Point3(-55,-65,20),Point3(-55,160,20)))
		##parte da frente
		collisionExterior.addSolid(CollisionPolygon(Point3(6,-65,10),Point3(55,-65,10),Point3(55,-65,20),Point3(6,-65,20)))
		collisionExterior.addSolid(CollisionPolygon(Point3(-55,-65,10),Point3(-8,-65,10),Point3(-8,-65,20),Point3(-55,-65,20)))
		##parte tras
		collisionExterior.addSolid(CollisionPolygon(Point3(55,160,10),Point3(-55,160,10),Point3(-55,160,20),Point3(55,160,20)))
		exterior = self.environ2.attachNewNode(collisionExterior)
		sef = self.environ2.attachNewNode(collisionWall1)
		
		collisionCatacumba = CollisionNode('catacumba')
		collisionCatacumba.addSolid(CollisionPolygon(Point3(53,160,-25),Point3(53,-65,-25),Point3(53,-65,-10),Point3(53,160,-10)))
		collisionCatacumba.addSolid(CollisionPolygon(Point3(-20,-65,-25),Point3(-20,160,-25),Point3(-20,160,-10),Point3(-20,-65,-10)))
		collisionCatacumba.addSolid(CollisionPolygon(Point3(-20,150,-25),Point3(55,150,-25),Point3(55,150,-10),Point3(-20,150,-10)))
		collisionCatacumba.addSolid(CollisionPolygon(Point3(-20,85,-25),Point3(55,85,-25),Point3(55,85,-10),Point3(-20,85,-10)))
		collisionCatacumba.addSolid(CollisionPolygon(Point3(55,103,-25),Point3(-20,103,-25),Point3(-20,103,-10),Point3(55,103,-10)))
		collisionCatacumba.addSolid(CollisionPolygon(Point3(55,-59,-25),Point3(-20,-59,-25),Point3(-20,-59,-10),Point3(55,-59,-10)))
		catacumbaC = self.catacumba.attachNewNode(collisionCatacumba)
		
		collisionBoard = CollisionNode('board')
		collisionBoard.addSolid(CollisionSphere(-5,126,-20,4))
		BoardC = self.salasecreta.attachNewNode(collisionBoard)
		collisionBoard.setIntoCollideMask(BitMask32.bit(0))
		collisionBoard.setFromCollideMask(BitMask32.allOff())
		
		collisionAbajurCatacumba = CollisionNode('abajurCat')
		collisionAbajurCatacumba.addSolid(CollisionSphere(0,17,-20,4))
		abajurCat = self.environ2.attachNewNode(collisionAbajurCatacumba)
		collisionAbajurCatacumba.setIntoCollideMask(BitMask32.bit(0))
		collisionAbajurCatacumba.setFromCollideMask(BitMask32.allOff())
		
		#armour collision
		collisionArmor = CollisionNode('armor')
		collisionArmor.addSolid(CollisionSphere(44,-60,-20,5))
		armor = self.environ2.attachNewNode(collisionArmor)
		collisionArmor.setIntoCollideMask(BitMask32.bit(0))
		collisionArmor.setFromCollideMask(BitMask32.allOff())
		###initialize the collision traverser
		base.cTrav = CollisionTraverser()
		##catacomb door collision
		collisionDoorCatacumba = CollisionNode('doorCatacumba')
		collisionDoorCatacumba.addSolid(CollisionSphere(-15,-42,-25,5))
		doorCatacumba = self.environ2.attachNewNode(collisionDoorCatacumba)
		collisionDoorCatacumba.setIntoCollideMask(BitMask32.bit(0))
		collisionDoorCatacumba.setFromCollideMask(BitMask32.allOff())
		
		#####initialize the collision node and put it in the traveser
		cn = CollisionNode('avatar')
        	fromObject = cn.addSolid(CollisionSphere(0,0,0,12))
		solid = self.avatar.attachNewNode(cn)
		base.cTrav.addCollider(solid,base.pusher)
        	base.pusher.addCollider(solid,self.avatar)
        	# init players floor collisions
        	ray = CollisionRay()
        	ray.setOrigin(0,0,-.2)
        	ray.setDirection(0,0,-1)
        	cn = CollisionNode('avatarRay')
        	cn.addSolid(ray)
		#####set bitmask for the player
        	cn.setFromCollideMask(BitMask32.bit(0))
        	cn.setIntoCollideMask(BitMask32.allOff())
        	solid = self.avatar.attachNewNode(cn)
		
		######now set the collision node who will fire the mini-games
		cn2 = CollisionNode('avatarEvent')
		fromObject2 = cn2.addSolid(CollisionSphere(0,-4,0,10))
		solid2 = self.avatar.attachNewNode(cn2)
		cn2.setIntoCollideMask(BitMask32.allOff())
		cn.setFromCollideMask(BitMask32.bit(2))
			
		####now set the collision nodes for the objects who will open mini-games
		colNode = CollisionNode('chair')
		chairSphere  = colNode.addSolid(CollisionSphere(-23,19,8,4))
		chairC  = self.chair.attachNewNode(colNode)
		colNode.setIntoCollideMask(BitMask32.bit(0))
		colNode.setFromCollideMask(BitMask32.allOff())

		collisionChairParalel = CollisionNode('chairParalel')
		chairParalelSphere = collisionChairParalel.addSolid(CollisionSphere(-23,45,8,4))
		chairParalelC = self.chairParalel.attachNewNode(collisionChairParalel)
		collisionChairParalel.setIntoCollideMask(BitMask32.bit(0))
		collisionChairParalel.setFromCollideMask(BitMask32.allOff())
		
		collisionChairHexagon = CollisionNode('chairHexagon')
		chairHexagonSphere = collisionChairHexagon.addSolid(CollisionSphere(-27,100,8,4))
		chairHexagonC = self.chairHexagon.attachNewNode(collisionChairHexagon)
		collisionChairHexagon.setIntoCollideMask(BitMask32.bit(0))
		collisionChairHexagon.setFromCollideMask(BitMask32.allOff())
		
		collisionChairTrap = CollisionNode('chairTrap')
		chairTrapSphere = collisionChairTrap.addSolid(CollisionSphere(-27,123,8,4))
		chairTrapC = self.chairTrap.attachNewNode(collisionChairTrap)
		collisionChairTrap.setIntoCollideMask(BitMask32.bit(0))
		collisionChairTrap.setFromCollideMask(BitMask32.allOff())
		
		collisionCubeAbajur = CollisionNode('cubeAbajur')
		cubeAbajurSphere = collisionCubeAbajur.addSolid(CollisionSphere(-22,33,11,3))
		cubeAbajurC = self.cubeAbajur.attachNewNode(collisionCubeAbajur)
		collisionCubeAbajur.setIntoCollideMask(BitMask32.bit(0))
		collisionCubeAbajur.setFromCollideMask(BitMask32.allOff())
		
		collisionCilinderAbajur = CollisionNode('cilinderAbajur')
		cilinderAbajurSphere = collisionCilinderAbajur.addSolid(CollisionSphere(30,96,11,3))
		cilinderAbajurC = self.cubeAbajur.attachNewNode(collisionCilinderAbajur)
		collisionCilinderAbajur.setIntoCollideMask(BitMask32.bit(0))
		collisionCilinderAbajur.setFromCollideMask(BitMask32.allOff())
		
		collisionPiramidAbajur = CollisionNode('piramidAbajur')
		piramidAbajurSphere = collisionPiramidAbajur.addSolid(CollisionSphere(30,143,11,3))
		piramidAbajurC = self.piramidAbajur.attachNewNode(collisionPiramidAbajur)
		collisionPiramidAbajur.setIntoCollideMask(BitMask32.bit(0))
		collisionPiramidAbajur.setFromCollideMask(BitMask32.allOff())
		
		collisionPiano = CollisionNode('piano')
		pianoSphere = collisionPiano.addSolid(CollisionSphere(40,120,11,7))
		pianoC = self.piano.attachNewNode(collisionPiano)
		collisionPiano.setIntoCollideMask(BitMask32.bit(0))
		collisionPiano.setFromCollideMask(BitMask32.allOff())

		collisionDoor = CollisionNode('door')###ante sala
		collisionDoor.addSolid(CollisionSphere(0,-5,8,4))
		cDoor = self.environ2.attachNewNode(collisionDoor)
		collisionEntranceDoor = CollisionNode('entranceDoor')
		collisionEntranceDoor.addSolid(CollisionSphere(0,-65,8,4))
		cEntranceDoor = self.environ2.attachNewNode(collisionEntranceDoor)
	
		collisionDoor1 = CollisionNode('door1')
		collisionDoor1.addSolid(CollisionSphere(-17,80,10,6))
		cDoor1 = self.door1.attachNewNode(collisionDoor1)
		collisionDoor1.setIntoCollideMask(BitMask32.bit(0))
		collisionDoor1.setFromCollideMask(BitMask32.allOff())
		
		collisionDoor2 = CollisionNode('door2')
		collisionDoor2.addSolid(CollisionSphere(17,80,10,6))
		collisionDoor2.setIntoCollideMask(BitMask32.bit(0))
		collisionDoor2.setFromCollideMask(BitMask32.allOff())
		cDoor2 = self.door1.attachNewNode(collisionDoor2)
		
		collisionSofa = CollisionNode('sofa')
		collisionSofa.addSolid(CollisionSphere(-35,-25,4,8))
		cSofa = self.environ2.attachNewNode(collisionSofa)
		
		collisionTable = CollisionNode('table')
		collisionTable.addSolid(CollisionSphere(30,-35,4,8))
		cTable = self.environ2.attachNewNode(collisionTable)
		
		####Initialize HandlerQueue - save the collisions , could be necessary
		self.nodeGroundHandler = CollisionHandlerQueue()
        	base.cTrav.addCollider(solid, self.nodeGroundHandler)
		
		base.cTrav.traverse(render)
		
		######initialize the collision handlerEvent() who will take care 
		######of the events generated by the collisions
		self.collHandEvent=CollisionHandlerEvent()
                self.collHandEvent.addInPattern('collide-%in')
		self.collHandEvent.addAgainPattern('collide-%in')
		
		base.cTrav .addCollider(solid2 , self.collHandEvent)
		
		self.accept("collide-bookCircle",self.colisao)
		self.accept("collide-bookSquare",self.colisao)
		self.accept("collide-piano",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-board",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-abajurCat",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-armor",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-door2",self.isInteracting,[self.keyMap["interact"],1])
		self.accept("collide-board",self.isInteracting,[self.keyMap["interact"],0])
		self.accept("collide-portrait",self.isInteracting,[self.keyMap["interact"],2])
		self.accept("collide-book",self.isInteracting,[self.keyMap["interact"],0])
		
		###show collisions
		self.count = 0
				
    ########
    ##@DESCRIPTION:imprimi na tela (no console) se o objeto foi interagido
    ##@PARAMETERES:collEntry
    ########
    def colisao(self,collEntry):
	      print "BOOK COLLIDING EVENT!!!"

    ########
    ##@DESCRIPTION:imprimi na tela (no console) detalhes da colisao
    ##@PARAMETERES:collEntry
    ########
    def isInteracting(self,event,Id,collEntry):
	    if(event==1):
		    if(Id==0):
		    	self.createViewport()
		    if(Id==1):
			self.goToCatacumba()
		    if(Id==2):
			self.goToSalaSecreta()
		    if(Id==3):
			self.goToSala2()
    ########
    ##@DESCRIPTION: define os componentes q participarao das perguntas carregadas pela ase
    ##@PARAMETERES: none
    ########
    def defineQuestions(self):
		nivel = self.m.retornaNivel()
		self.b= baseDeDados.Base(nivel)

		self.perguntaPassatempo = self.b.obterQuestaoP()
		self.respostaPassatempo = self.b.obterRespostaCorretaP()
		self.outrasRespostasPassatempo = self.b.obterOutrasRespostasP()
		self.modeloPassatempo = self.b.obterModeloP()
		self.dicaPassatempo = self.b.obterDicaP()

		self.pergunta = OnscreenText(self.perguntaPassatempo,style=1,fg=(1,1,1,1),pos=(-1.3,-0.50),align=TextNode.ALeft,scale=.08)
		
		self.button1 = DirectButton(text=("X"),scale=(.07,1,.06),command= self.RespostaVer,extraArgs=[self.outrasRespostasPassatempo[0]])
		self.button1.setPos(-1.2,-0.65,-0.65)
		self.resposta1 = OnscreenText(self.outrasRespostasPassatempo[0],style=1,fg=(1,1,1,1),
                        pos=(-1.1,-0.65),align=TextNode.ALeft,scale=.06)
		
		self.button2 =DirectButton(text=("X"),scale=(.07,1,.06),command=self.RespostaVer,extraArgs=[self.outrasRespostasPassatempo[1]])
		self.button2.setPos(-1.2,-0.65,-0.75)
		self.resposta2 = OnscreenText(self.outrasRespostasPassatempo[1],style=1,fg=(1,1,1,1),
                        pos=(-1.1,-0.75),align=TextNode.ALeft,scale=.06)
		
		self.button3 =DirectButton(text=("X"),scale=(.07,1,.06),command=self.RespostaVer,extraArgs=[self.outrasRespostasPassatempo[2]])
		self.button3.setPos(-1.2,-0.65,-0.85)
		self.resposta3 = OnscreenText(self.outrasRespostasPassatempo[2],style=1,fg=(1,1,1,1),
                        pos=(-1.1,-0.85),align=TextNode.ALeft,scale=.06)
		
		self.button4 =DirectButton(text=("X"), scale=(.07,1,.06),command=self.RespostaVer,extraArgs=[self.outrasRespostasPassatempo[3]])
		self.button4.setPos(-1.2,-0.65,-0.95)
		self.resposta4 = OnscreenText(self.outrasRespostasPassatempo[3],style=1,fg=(1,1,1,1),
                        pos=(-1.1,-0.95),align=TextNode.ALeft,scale=.06)

		self.questions = 1

    ########
    ##@DESCRIPTION: destroi a viewport carregada
    ##@PARAMETERES: none
    ########
    def destroyWindow(self):
		self.window.destroy(0)
		self.keysActive =1
		print "destroyWindow"
		self.activateKeys()
		self.ignore("enter")
		
    ########
    ##@DESCRIPTION: metodo responsavel por carregar informacoes relacionadas as mensagens de navegacao, verificar as respostas, carregar os 
    ##              ambientes e conversar com a maquina de estados
    ##@PARAMETERES:
    ########		
    def RespostaVer(self, resposta):
	self.time1.destroy()
	if (self.respostaPassatempo == resposta):
		print "Nivel Anterior:",self.m.retornaNivel()
		self.m.passarNivel()
		
		if(self.m.retornaNivel() == 2):
			comp = self.m.compl[0]
			p1 = "Muito bem! Voce conseguiu entrar na biblioteca!\n O desafio comeca agora. \n \n Seu proximo passo sera localizar um objeto \n que possua uma figura plana \n"
			self.mess = p1+comp
			self.window = createWindow.createWindow(self.mess)
			self.goToSala1()
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0
			
		if(self.m.retornaNivel() == 3):
			self.ignore(self.m.objetoColididoN2)
			comp = self.m.compl[1]
			p2 = "Caramba, voce conseguiu!\n Mas ainda ha muito a fazer...\n \n Agora procure por um objeto \n cuja forma seja\n"
			self.mess = p2+comp
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0
			
		if(self.m.retornaNivel() == 4):
			self.ignore(self.m.objetoColididoN3)
			comp = self.m.compl[2]
			p3 = "Ufff... mais uma etapa vencida.\n \nVeja agora que uma das estantes contem um livro\n que possui uma figura plana \n"
			self.mess= p3+comp+" Ache-o para \n liberar o proximo passatempo. \n \n \n \n \n \n \n Rapido!!!"
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0
			
		if(self.m.retornaNivel() == 5):
			self.ignore(self.m.objetoColididoN4)
			self.mess = "Essa foi mais complicada, \n mas voce mostrou que consegue!\n \n Para seguir buscando o livro secreto,\n localize um objeto que seja \n formado por diversos paralelepipedos"
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0

		if(self.m.retornaNivel() == 6):
			self.ignore("collide-piano")
			self.mess = "Tem algo de muito misterioso no ar... \n  \nEssa nao!! \n Voce precisa descobrir a porta certa para a \ncatacumba e localizar um objeto que \n teve origem no seculo equivalente ao numero\n de vertices de um prisma de base octogonal."
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0

		if(self.m.retornaNivel() == 7):
			self.ignore("collide-armor")
			self.mess = "Voce conseguiu! \n A armadura desta biblioteca foi feita no seculo XVI! \n \n Mas que lugar sombrio, hein? \n\n Vamos sair logo daqui\n encontrando um objeto que seja formado por uma\n figura que lembre um tronco de cone."
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0

		if(self.m.retornaNivel() == 8):
			self.ignore("collide-abajurCat")
			self.mess = "Essas foram de arrepiar... \n Falta pouco! \n \n Agora volte para a biblioteca e va ate o grande quadro\n para descobrir uma sala secreta \n onde esta o ultimo passatempo"
			self.window = createWindow.createWindow(self.mess)
			self.keysActive = 2
			self.activateKeys()
			self.accept("enter",self.destroyWindow)
			self.countErrors = 0	

		if(self.m.retornaNivel() == 9):
			self.removeInstructions()
			self.time1.destroy()
			taskMgr.remove('moveTask')
			print "GAME OVER!!"
			self.window = createWindow.createWindow("Voce conseguiu terminar o jogo a tempo. \n \n PARABENS !! \n \n O livro esta a salvo e os ladroes foram capturados. \n\n Voce tornou-se um heroi! \n\n\n\n\n\n Acesse a camara secreta agora!")
			self.accept("enter",self.playMovie)
		self.disableViewport()
		print "Nivel Atual:",self.m.retornaNivel()
	else:
		print "Erro"
		
		self.tries = self.tries + 1
		self.disableViewport()

		if(self.countErrors == 1):
			print "GAME OVER!!"
			self.time1.destroy()
			taskMgr.remove('moveTask')
			self.imageObject1 = OnscreenImage(image = "imagens/preto.jpg", pos = (0, 0, 0),scale=(1.35,1,1))
			self.mensagemFinal1 = TextNode('dica')
			self.mensagemFinal1.setText("GAME OVER\n\n\n\n Mais sorte da proxima vez!!!\n")
			self.mensagemFinal1.setWordwrap(15.0)
			self.mensagemFinal1.setTextColor(1, 0, 0, 1)
			self.mensagemNode1 = aspect2d.attachNewNode(self.mensagemFinal1)
			self.mensagemFinal1.setAlign(self.mensagemFinal1.ACenter)
			self.mensagemNode1.setPos(X_PADRAO+1.3, 0,0.1)
			self.mensagemFinal1.setShadow(0.05, 0.05)
			self.mensagemFinal1.setShadowColor(0, 0, 0, 1)
			self.mensagemNode1.setScale(0.18)
			self.removeInstructions()
			self.keysActive = 0
			self.activateKeys()
		
		if(self.countErrors == 0):
			str = "Atencao!! Voce errou e perdeu tempo!! \n\n Ai vai uma DICA: \n \n "
			message = str+self.dicaPassatempo
			self.window = createWindow.createWindow(message)
			self.accept("enter",self.errorMessage)
			self.countErrors = 1
			
    ########
    ##@DESCRIPTION: carrega a tela de ajuda do jogo
    ##@PARAMETERES: none
    ########		
    def helpMessage(self):
	    self.window = createWindow.createWindow("- Tempo maximo: 32 minutos\n \n-Voce pode errar no maximo uma vez em cada passatempo! \n \n- Cada erro subtrai 5 minutos do tempo restante \n \n- Cada espaco entre os pinos do geoespaco\n vale uma unidade de medida \n \n \n \n \n \n M E N U    D E   A J U D A " )
	    self.keysActive = 0
	    self.ignore("space")
	    self.activateKeys()
	    self.ignore("h")
	    self.ignore("d")
	    self.accept("enter",self.destroyWindow)

    ########
    ##@DESCRIPTION: carrega a ultima dica de navegacao do jogo
    ##@PARAMETERES: none
    ########
    def ultimaDica(self):
	    self.window = createWindow.createWindow(self.mess)
	    self.keysActive = 0
	    self.ignore("space")
	    self.activateKeys()
	    self.ignore("d")
	    self.ignore("h")
	    self.accept("enter",self.destroyWindow)

    ########
    ###@DESCRIPTION: carrega a tela de Game Over e mata a thread do tempo
    ##@PARAMETERES: none
    ########
    def gameOver(self):
		self.imageObject1 = OnscreenImage(image = "imagens/preto.jpg", pos = (0, 0, 0),scale=(1.35,1,1))
		self.mensagemFinal1 = TextNode('dica')
		self.mensagemFinal1.setText("O tempo acabou\n Que pena , os ladroes chegaram antes ao livro\n Tente novamente mais tarde!\n")
		self.mensagemFinal1.setWordwrap(15.0)
		self.mensagemFinal1.setTextColor(1, 0, 0, 1)
		self.mensagemNode1 = aspect2d.attachNewNode(self.mensagemFinal1)
		self.mensagemFinal1.setAlign(self.mensagemFinal1.ACenter)
		self.mensagemNode1.setPos(X_PADRAO+1.3, 0,0.1)
		self.mensagemFinal1.setShadow(0.05, 0.05)
		self.mensagemFinal1.setShadowColor(0, 0, 0, 1)
		self.mensagemNode1.setScale(0.18)
		self.removeInstructions()
		self.keysActive = 0
		self.activateKeys()
		
    ########
    ##@DESCRIPTION: carrega a viewport da mensagem de erro
    ##@PARAMETERES: none
    ########
    def errorMessage(self):
	self.destroyWindow()
	self.createViewport()
	self.ignore("enter")

    ########
    ##@DESCRIPTION: destroi os componentes dos passatempos
    ##@PARAMETERES:
    ########
    def destroyQuestions(self):
	    if(self.questions)==1:
		    self.pergunta.destroy()
		    self.resposta1.destroy()
		    self.resposta2.destroy()
		    self.resposta3.destroy()
		    self.resposta4.destroy()
		
		    self.button1.destroy()
		    self.button2.destroy()
		    self.button3.destroy()
		    self.button4.destroy()
		    self.questions = 0

    ########
    ##@DESCRIPTION: rotaciona a visao do jogador
    ##@PARAMETERES: as coordenadasXYZ
    ########
    def rotateMinigame(self,cX,cY,cZ):
	    if(self.viewportCreated == 1):
		    self.minigame.setHpr(self.minigame.getHpr()+Point3(cX,cY,cZ))

    ########
    ##@DESCRIPTION: Create Viewport that will show the mini-games
    ##@PARAMETERES: none
    ########
    def createViewport(self):
	#if self.keyMap["interact"] == 1:
		self.removeInstructions()
		self.instrucoes = OnscreenText("[SETAS Direita/Esquerda/Baixo/Cima] - Movimentar o tabuleiro",style=1,fg=(1,1,1,1),
                        pos=(-1.3,0.90),align=TextNode.ALeft,scale=.05)
		self.viewportCreated = 1
		self.keysActive = 2
		self.activateKeys()
		print "CREATING VIEWPORT"
		print self.viewportCreated
		self.defineQuestions()
		print self.keyMap["interact"]
		self.mVPRoot = NodePath("ViewportRoot")
		#time.sleep(1)
		# Add a simple 3D axes model to the scene graph
		minigameId = int(self.b.obterModeloP())
		print minigameId,"minigameId"

		# Create the camera to render the viewport
		self.mVPCamera = Camera("mVPCamera")
		self.mVPCamera.setScene(self.mVPRoot)
		self.mVPCameraNode = self.mVPRoot.attachNewNode(self.mVPCamera)

		self.mVPCameraNode.setPos(0,-45,6)
		self.mVPCameraNode.setHpr(0,0,0)

		# Create the display region
		self.mVPDisplayRegion = \
        		base.win.makeDisplayRegion(0,1.0,0,1.3)
		self.mVPDisplayRegion.setClearColorActive(1)
		self.mVPDisplayRegion.setClearDepthActive(1)
		self.mVPDisplayRegion.setCamera(self.mVPCameraNode)
		self.mVPDisplayRegion.setClearColor(VPColor)
		#######
		if(minigameId == 0):
			self.minigame = loader.loadModel("models/geoespaco2.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 1):
			self.minigame = loader.loadModel("models/geoespaco_octaedro.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId ==2):
			self.minigame = loader.loadModel("models/geoespaco_hexagono.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 3):	    
			self.minigame = loader.loadModel("models/geoespaco_pentagono.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+2)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 4):
			self.minigame = loader.loadModel("models/geoespaco_piramidetriangulo.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 5):
			self.minigame = loader.loadModel("models/geoespaco_paralelogramo.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 6):
			self.minigame = loader.loadModel("models/geoespaco_cubo.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		if(minigameId == 7):
			self.minigame = loader.loadModel("models/geoespaco2.bam")
			self.minigame.setZ(self.minigame.getZ()+2)
			self.minigame.setScale(self.minigame.getScale()*0.9)
			self.minigame.setHpr(-20,5,0)
			self.minigame.setX(self.minigame.getX()+1)
			self.minigame.reparentTo(self.mVPRoot)
		lAttrib = LightAttrib.makeAllOff()
		ambientLight = AmbientLight( "ambientLight" )
		
	
		self.mVPRoot.attachNewNode( ambientLight.upcastToPandaNode() ) 
		self.mVPRoot.node().setAttrib( lAttrib )
		return Task.cont
		
    ########
    ##@DESCRIPTION: desabilita a view port
    ##@PARAMETERES: none
    ########
    def disableViewport(self):
	    print ""
	    self.instrucoes.destroy()
	    print "entrou!",self.viewportCreated
	    if self.viewportCreated ==1:
		base.win.removeDisplayRegion(self.mVPDisplayRegion)
		self.minigame.removeNode()
		
		self.keysActive = 0
		self.activateKeys()
		self.destroyQuestions()
		self.addInstructions()

    ########
    ##@DESCRIPTION: redireciona ao ambiente da catacumba
    ##@PARAMETERES: none
    ########
    def goToCatacumba(self):
	    self.avatar.setPos(-1.5,-12,-20)
	    camera.setPos(-1.5,-12,-20)

    #######
    ##@DESCRIPTION: redireciona ao ambiente da sala secreta
    ##@PARAMETERES: none
    ########
    def goToSalaSecreta(self):
	    self.avatar.setPos(48,158,-18)
	    camera.setPos(48,158,-18)

    #######
    ##@DESCRIPTION: redireciona ao ambiente da sala 1
    ##@PARAMETERES: none
    ########
    def goToSala1(self):
	    self.avatar.setPos(0,40,12)
	    camera.setPos(0,40,12)
	
    #######
    ##@DESCRIPTION: redireciona ao ambiente da sala 2
    ##@PARAMETERES: none
    ########    
    def goToSala2(self):
	    self.avatar.setPos(7,125,12)
	    camera.setPos(7,125,12)
	
	
    def goZ(self,ie):
	    if(ie == 0):
		    self.avatar.setZ(self.avatar.getZ()-1)
		    camera.setZ(camera.getZ()-1)
		    print self.avatar.getPos()
		    print self.avatar.getHpr()
	    if(ie == 1):
		    self.avatar.setZ(self.avatar.getZ()+1)
		    camera.setZ(camera.getZ()+1)
		    print self.avatar.getPos()	    

    #######
    ##@DESCRIPTION: activate the keys or deactivate keys as necessary
    ##@PARAMETERES: none
    ########
    def activateKeys(self):
	    if(self.keysActive == 0):
		    print "nothing to do"
		    self.ignore("arrow_up")
	    	    self.ignore("arrow_down")
	            self.ignore("arrow_left")
	            self.ignore("arrow_right")
	    if(self.keysActive == 1):
		    ####ativa teclas para os passatempos
		    print "activating keys"
		    self.accept("escape", sys.exit)
		    self.accept("arrow_left", self.setKey, ["left",1])
		    self.accept("arrow_right", self.setKey, ["right",1])
		    self.accept("arrow_up", self.setKey, ["forward",1])
		    self.accept("arrow_down", self.setKey, ["backward",1])
		    self.accept("arrow_left-up", self.setKey, ["left",0])
		    self.accept("arrow_right-up", self.setKey, ["right",0])
		    self.accept("arrow_up-up", self.setKey, ["forward",0])
		    self.accept("arrow_down-up", self.setKey, ["backward",0])
		    self.accept("c",self.goToCatacumba)
		    self.accept("s",self.goToSalaSecreta)
		    self.accept("p",self.goToSala1)
		    self.accept("d",self.ultimaDica)
		    self.accept("h",self.helpMessage)
		    self.accept("space",self.setKey,["interact",1])
		    
	    if(self.keysActive == 2):
		    ####desativa teclas para os passatempos!
		    print "deactivating keys"
		    self.ignore("arrow_left")
		    self.ignore("arrow_right")
		    self.ignore("arrow_up")
		    self.ignore("arrow_down")
		    self.ignore("arrow_left-up")
		    self.ignore("arrow_right-up")
		    self.ignore("arrow_up-up")
		    self.ignore("arrow_down-up")
		    self.ignore("o")
		    self.ignore("d")
		    self.ignore("h")
		    self.ignore("space")
		    self.accept("arrow_right",self.rotateMinigame,[10,0,0])
		    self.accept("arrow_left",self.rotateMinigame,[-10,0,0])
		    self.accept("arrow_up",self.rotateMinigame,[0,10,0])
		    self.accept("arrow_down",self.rotateMinigame,[0,-10,0])
		    self.act = 1

    ########
    ##@DESCRIPTION: habilitar mouse
    ##@PARAMETERES: none
    ########
    def enableMouse(self):
		mat=Mat4(camera.getMat())
		mat.invertInPlace()
		base.mouseInterfaceNode.setMat(mat)
		base.enableMouse()
		print "enabling mouse control"
		
		
    ########
    ##@DESCRIPTION: desabilita a funcao default do mouse de controle da camera
    ##@PARAMETERES: none
    ########
    def disableMouse(self):
	    base.disableMouse()
	    print "disabling mouse control"


    ########
    ##@DESCRIPTION: abre o jogo em primeira pessoa
    ##@PARAMETERES: none
    ########
    def abrirPrimeiroPassatempo(self):
    	self.window.destroy(0)
	self.createViewport()
	self.ignore("enter")
    
    ########
    ##@DESCRIPTION: remove as isntrucoes da tela da biblioteca
    ##@PARAMETERES: none
    ########
    def removeInstructions(self):
	    self.message1.destroy()
	    self.message2.destroy()
	    self.message3.destroy()
	    self.message4.destroy()
	    self.message5.destroy()
	    self.message6.destroy()

    ########
    ##@DESCRIPTION: adiciona as isntrucoes da tela da biblioteca
    ##@PARAMETERES: none
    ########
    def addInstructions(self):
	self.time1 = OnscreenText("00: 00",style=1,fg=(1,1,1,1),
                        pos=(1.3,0.95),align=TextNode.ALeft,scale=.05)
	self.message1 = OnscreenText("[ESC] Sair",style=1,fg=(1,1,1,1),
                        pos=(-1.3,0.95),align=TextNode.ALeft,scale=.05)
        self.message2 = OnscreenText("[Setas Direita/Esquerda] - Rotacionar a camera",style=1,fg=(1,1,1,1),
                        pos=(-1.3,0.90),align=TextNode.ALeft,scale=.05)
        self.message3 = OnscreenText("[Setas Cima/Baixo] - Andar para frente/para tras",style=1,fg=(1,1,1,1),
                        pos=(-1.3,0.85),align=TextNode.ALeft,scale=.05)
        self.message4 = OnscreenText("[Barra de Espaco] - Interagir com os objetos",style=1,fg=(1,1,1,1),pos=(-1.3,0.80),
                        align=TextNode.ALeft,scale=.05)
	self.message5 = OnscreenText("[D] - Exibir ultima Dica",style=1,fg=(1,1,1,1),pos=(-1.3,0.75),align=TextNode.ALeft,scale=.05)
	self.message6 = OnscreenText("[H] - Ajuda",style=1,fg=(1,1,1,1),pos=(-1.3,0.70),align=TextNode.ALeft,scale=.05)		
	
    ########
    ##@DESCRIPTION: metodo de inicializacao da classe
    ##@PARAMETERES: none
    ########
    def __init__(self):
	self.m = MaquinaDeEstados.criaMaquinaDeEstados()
	self.floaterPos = floaterPos	
        # Camera position.
        self.cameraPos = cameraPos
	
	# Create key point. It will be used as a parent for
        # the camParent, the actor placeholder and the floater.
        self.keyPoint = NodePath(PandaNode("keyPoint"))
        self.keyPoint.reparentTo(render)
	self.addInstructions()
	# Create an empty node - the floater - the camera will look at.
        self.floater = NodePath(PandaNode("floater"))
        self.floater.reparentTo(self.keyPoint)
        self.floater.setPos(self.floaterPos[0],
                            self.floaterPos[1],
                            self.floaterPos[2])
	self.window = createWindow.createWindow("Sera que voce conseguira enfrentar tamanho desafio?  \n Prove! \nUse seus conhecimentos para responder \n a  pergunta a seguir e com isso entrar na biblioteca! \n \n Voce tem 32 minutos \n para resolver todos os passatempos \n e encontrar o livro. \n \n \n \n Cuidado para nao errar e perder tempo! \n Depressa!") 
	
        # Create an empty node - camera parent. Set it at the same
        # height as the floater. When we move the camera,
        # it will move further or closer to the camParent.
        self.camParent = NodePath(PandaNode("camParent"))
        self.camParent.reparentTo(self.keyPoint)
        self.camParent.setPos(0, self.floaterPos[2], self.floaterPos[2])

        # Create the camera and reparent it to the self.camParent.
        base.camera.reparentTo(self.camParent)
        base.camera.setPos(self.cameraPos[0],
                            self.cameraPos[1],
                            self.cameraPos[2])
        base.camera.lookAt(self.floater)
	self.viewportCreated = 0
	self.totalTime = 0.0
	self.minutes = 0.0
	self.seconds = 0.0   
        self.prevtime = 0
	self.keysActive = 1
	self.activateKeys()
        self.LoadModels()	
	self.LoadLights()

	props = WindowProperties()

	# Move mouse to the middle of the screen.
        base.win.movePointer(0, screenCenterX, screenCenterY)
	
	self.keyMap = {"left":0, "right":0, "forward":0, "backward":0, "cam-left":0, "cam-right":0, "interact":0, "d":0, "a":0, "b":0, "p": 0,"mouse2":0}
	
	taskMgr.add(self.move,"moveTask")#####adiciona a task de movimentos
	self.Visao(1)
	
       	self.accept("escape",sys.exit)
	self.keysActive = 2
	self.activateKeys()
	self.accept("enter",self.abrirPrimeiroPassatempo)
	
	self.setUpCollision()
